#ifndef DIALOGCONTROLLER_H
#define DIALOGCONTROLLER_H

#include <QThread>
#include <QIcon>
#include <QMessageBox>
#include "../NeuralNetwork/NNApprox.h"
#include "../NeuralNetwork/NNDevice.h"

#include "../ServiceLocator/ServiceLocator.h"
#include "DeviceOptionsDialog.h"

class DeviceController : public QThread
{
    Q_OBJECT

public slots:
    void openNetwork(NNApprox* nn, QString* filename);

    void store();
    void load();
    void deviceOptions();

    void updateDevices();
    void changeDevice(NNDevice* currentDevice);

signals:
    void networkUpdated(NNApprox* nn);
    void deviceQuery();

    void enableDeviceOptions();

    void enableStoreLoad();
    void disableStoreLoad();

    void enableDeviceTab();
    void deviceChanged(NNDevice* device);

private:

   NNApprox* myNetwork;
   NNDevice* currentDevice;

   void error(const char* title, const char* message);

public:
    DeviceController();
};

#endif // DIALOGCONTROLLER_H
