#ifndef DEVICEOPTIONSDIALOG_H
#define DEVICEOPTIONSDIALOG_H

#include <QDialog>
#include <QComboBox>
#include <QLabel>
#include <QGridLayout>
#include <QPushButton>
#include "../ServiceLocator/DeviceProvider.h"

class DeviceOptionsDialog : public QDialog
{
    Q_OBJECT

signals:
    void changeDevice(NNDevice* device);

public:
    DeviceOptionsDialog(DeviceProvider* provider);

    bool isReady();

public slots:
    void submitted();
    void cancelled();
    void configure();

    void indexChanged(int i);

private:
    bool ready;
    NNDevice* currentDevice;

    QGridLayout* layout;
    QComboBox*   combo;
    QLabel*      label;
    QPushButton* submitButton;
    QPushButton* cancelButton;
    QPushButton* configureButton;
};

#endif // DEVICEOPTIONSDIALOG_H
