#ifndef FILECONTROLLER_H
#define FILECONTROLLER_H

#include <QtGui/QFileDialog>
#include <QtGui/QMessageBox>
#include <QThread>
#include <QIcon>

#include <cstdio>
#include <cstdlib>

#include "../FileIO/NNReader.h"
#include "../FileIO/NNWriter.h"
#include "NewFileDialog.h"

class FileController: public QThread
{
    Q_OBJECT

public slots:

    void newFile();
    void open();
    bool save();
    bool saveAs();
    void random();
    void close();

    void createFile(int version);

    void updateNetwork(NNApprox* nn);

signals:
    void networkOpened(NNApprox* nn, QString* filename);
    void networkUpdated(NNApprox* nn);

    void activateSave();
    void deactivateSave();

    void closeCancelled();
    void changedFilename(QString* filename);

public:
    FileController();

private:
    bool isSaved;

    NNApprox* loadedNetwork;

    QString*  filename;

    bool closeUnSaved();
    void error(const char* title, const char* message);
};

#endif // FILECONTROLLER_H
