#ifndef TESTOPTIONSDIALOG_H
#define TESTOPTIONSDIALOG_H

#include <QDialog>
#include <QGridLayout>
#include <QComboBox>
#include <QPushButton>
#include <QLineEdit>
#include <QLabel>
#include "../NeuralNetwork/NNTester.h"
#include "../ServiceLocator/TestProvider.h"

class TestOptionsDialog : public QDialog
{

    Q_OBJECT

signals:
    void changeTester(NNTester* tester);
    void changeIterEdit(int iter);

public:
    TestOptionsDialog(TestProvider* provider, NNTester* currentTester, int iter);

    bool isReady();

public slots:
    void submitted();
    void cancelled();
    void iterEditted(QString text);

    void indexChanged(int i);

private:
    bool ready;

    NNTester* currentTester;
    int       iter;

    QGridLayout* layout;
    QComboBox*   combo;
    QLabel*      testerLabel;
    QLabel*      iterLabel;
    QLineEdit*   iterEdit;
    QPushButton* submitButton;
    QPushButton* cancelButton;

};

#endif // TESTOPTIONSDIALOG_H
