#ifndef TRAINEROPTIONSDIALOG_H
#define TRAINEROPTIONSDIALOG_H

#include <QDialog>
#include <QGridLayout>
#include <QComboBox>
#include <QPushButton>
#include <QLineEdit>
#include <QLabel>
#include "../NeuralNetwork/NNTrainer.h"
#include "../ServiceLocator/TrainerProvider.h"

class TrainerOptionsDialog : public QDialog
{

    Q_OBJECT

signals:
    void changeTrainer(NNTrainer* trainer);
    void changeConstantsEdit(int iter, int maxIterations, double gamma, double momentum);

public:
    TrainerOptionsDialog(TrainerProvider* provider, NNTrainer* currentTrainer, int iter, int maxIterations, double gamma, double momentum);

    bool isReady();

public slots:
    void submitted();
    void cancelled();
    void iterEditted(QString text);
    void maxIterEditted(QString text);
    void gammaEditted(QString text);
    void momentumEditted(QString text);

    void indexChanged(int i);

private:
    bool ready;

    NNTrainer* currentTrainer;
    int       iter;
    int       maxIterations;
    double    gamma;
    double    momentum;

    void checkInputs();

    QGridLayout* layout;
    QComboBox*   combo;
    QLabel*      trainerLabel;
    QLabel*      iterLabel;
    QLineEdit*   iterEdit;
    QLabel*      maxIterLabel;
    QLineEdit*   maxIterEdit;
    QLabel*      gammaLabel;
    QLineEdit*   gammaEdit;
    QLabel*      momentumLabel;
    QLineEdit*   momentumEdit;
    QPushButton* submitButton;
    QPushButton* cancelButton;

};

#endif // TRAINEROPTIONSDIALOG_H
