/**
* Matthew Netsch
* Feb 2010
*
* NNData.h
*
* Reads a file that contains data for
* training or testing. Then serves as
* a provider for this information.
*/

#ifndef __NNData__
#define __NNData__

#include <cstdio>
#include <cstdlib>
#include <QThread>
#include <QMessageBox>
#include <QIcon>

class NNData : public QThread
{
    Q_OBJECT

     signals:
        void wrongVersion(int version);
        void doneLoading(QString filename);
        void loading();

      private:
              double    **positions;
              double     *outputs;
              int        *posLen;
              int         numPositions;

              int         version;

      public:
              NNData();
              ~NNData();
              
              /* Mutators */
              void destroyData();
              void setVersion(int version);

              /* Accessors */
              int getNumData();
              int getVersion();
              double getOutput(int index);
              double* getData(int index, int* len);

              /* Load Threads */
              void run(QString filename);
              virtual void run();
              void load();

              QString filename;
};

#endif
