/**
* Matthew Netsch
* Feb 2010
*
* NNWriter.cpp
*
* Writer for writing a neural network file.
*/

#include "NNWriter.h"

/* Saves network to file provided */
void NNWriter::save(FILE* pFile, NNApprox* approx)
{
     /* Write the version */
     __int32 version = approx->getVersion();
     fwrite( &version , sizeof(__int32), 1, pFile);
     
     int numWeights = 0;
     double* weights = approx->load_weights(&numWeights);

     /* Writes the total number of weights */
     __int32 length = numWeights;
     fwrite( &length, sizeof(__int32), 1, pFile);
     
     /* Write the weights to the file */
     fwrite( weights, sizeof(double), numWeights, pFile);
     
}
