#ifndef NNTESTER_H
#define NNTESTER_H

#include <QThread>
#include <cmath>

#include "NNApprox.h"
#include "../FileIO/NNData.h"
#include "../../../include/qwt_scale_draw.h"

class NNTester : public QThread
{
    Q_OBJECT

    private:
       /* Network and Data */
       NNApprox* myNetwork;
       NNData*   testingData;

       bool stopThis;

protected:
       virtual void clearStats() = 0;

    public slots:
       void stopTesting();

    signals:
       void doneTesting();
       void testCycleDone(double percentDone, double error, QString* stats);

    public:
        NNTester();

        virtual void run();
        virtual double getError(double* outputs, int outLen, double expectedOutput) = 0;
        virtual QString* getName() = 0;
        virtual QString* getStats() = 0;

        virtual QString* getScaleName() = 0;
        virtual double getScaleMax() = 0;
        virtual QwtScaleDraw* getScaleDraw() = 0;

        void run(NNApprox* approx, NNData* data);

};

#endif // NNTESTER_H
