/**
* Matthew Netsch
* Feb 2010
*
* TesterThread.cpp
*
* A thread that performs testing on
* a neural network and publishes the
* results.
*/

#include "NNTrainer.h"

/* Constructor */
NNTrainer::NNTrainer()
{
    myNetwork   = NULL;
    trainingData = NULL;

    maxIterations = 0;
    gamma = 0;
    momentum = 0;

    stopThis    = false;
}

/* Wrapper for the thread's entry method */
void NNTrainer::run(NNApprox* approx, NNData* data, int maxIterations, double gamma, double momentum)
{
    /* Initalizes for a testing session */
    myNetwork   = approx;
    trainingData = data;
    this->maxIterations = maxIterations;
    this->gamma = gamma;
    this->momentum = momentum;

    stopThis    = false;

    /* Starts the testing session */
    start();
}

/* Slot that stops the testing cycle if called */
void NNTrainer::stopTraining()
{
    stopThis = true;
}

