/**
* Matthew Netsch
* Feb 2010
*
* DeviceProvider.h
*
* Header file for a thread that keeps
* track of all devices and their
* connective states.
*/

#ifndef DEVICEPROVIDER_H
#define DEVICEPROVIDER_H

#include <QThread>
#include "DeviceTester.h"


class DeviceProvider : public QThread
{
    Q_OBJECT

signals:
    void updateDevices();
    

private:
    NNDevice**     devices;
    DeviceTester** testers;
    int            numDevices;

public:
    DeviceProvider();
    ~DeviceProvider();

    void load(NNDevice* device);
    NNDevice** queryDevices(int* len);

    virtual void run();
};

#endif // DEVICEPROVIDER_H
