#ifndef SERVICELOCATOR_H
#define SERVICELOCATOR_H

#include <cstdlib>

#include "NNFactoryLocator.h"
#include "DeviceProviderLocator.h"
#include "TestProviderLocator.h"
#include "TrainerProviderLocator.h"

class ServiceLocator:  public NNFactoryLocator,
                       public DeviceProviderLocator,
                       public TestProviderLocator,
		       public TrainerProviderLocator
{
private:
    static ServiceLocator** instances;
    static int numInstances;

public:
    static ServiceLocator* locator(int version);
    static void load(ServiceLocator* locator);
    static ServiceLocator** getInstances(int* num);

    virtual NNFactory*      LocateNNFactory();
    virtual DeviceProvider* LocateDeviceProvider();
    virtual TestProvider*   LocateTestProvider();
    virtual TrainerProvider* LocateTrainerProvider();

    virtual int getVersion();

    virtual char* toString();
 };

#endif // SERVICELOCATOR_H
