#ifndef NETWORKTABLE_H
#define NETWORKTABLE_H

#include <QTableWidget>
#include "../NeuralNetwork/NNApprox.h"

class NetworkTable : public QTableWidget
{
Q_OBJECT

public slots:
    void nodeChanged(int layerNum, int node);
    void weightChanged(QTableWidgetItem* item);
    void weightEntered(QTableWidgetItem* item);

    void openNetwork(NNApprox* nn, QString* filename);
    void updateNetwork(NNApprox* nn);

signals:
    void changeNode(int node);
    void networkUpdated(NNApprox* nn);

public:
    NetworkTable();

private:
    NNApprox* myNetwork;
    int currentLayer;
    int currentNode;

    bool isUpdating;

};

#endif // NETWORKTABLE_H
