#ifndef NETWORKVIEWTAB_H
#define NETWORKVIEWTAB_H

#include <cstdlib>
#include <cstdio>

#include <QWidget>
#include <QSplitter>

#include <QTableWidget>
#include <QGraphicsView>

#include "TabView.h"
#include "NetworkView.h"
#include "NetworkTable.h"

class NetworkViewTab : public TabView
{
    Q_OBJECT

public:
    NetworkViewTab();

    virtual status* getStatus();

public slots:
    void openNetwork(NNApprox* nn, QString* filename);
    void changedFilename(QString* filename);

    void changeNode(int node);
    void changeValue(int value);

private:
    NetworkTable*  table;
    NetworkView*   view;

    NNApprox* loadedNetwork;
    QString*  filename;
    int       currentNode;
    int       value;
};

#endif // NETWORKVIEWTAB_H
