#include "TabView.h"

TabView::TabView()
{
    setAutoFillBackground(true);

    splitter = new QSplitter(this);

    QHBoxLayout* layout = new QHBoxLayout();
    layout->addWidget(splitter);
    layout->setSpacing(6);
    layout->setContentsMargins(3, 3, 3, 3);

    setLayout(layout);

    leftHeader = new QLabel(tr(""));

}

void TabView::construct(QWidget* left, QWidget* right)
{
    QLabel* header = new QLabel(tr(""));
    header->setText(leftHeader->text());
    leftLayout = new QVBoxLayout();
    leftLayout->addWidget(header);
    leftLayout->addWidget(left);

    leftLayout->setSpacing(6);
    leftLayout->setContentsMargins(0, 3, 0, 0);

    leftWidget = new QWidget();
    leftWidget->setLayout(leftLayout);

    splitter->addWidget(leftWidget);
    splitter->addWidget(right);

    QList<int> list;
    list.append(218);
    list.append(695);
    splitter->setSizes(list);

    splitter->setChildrenCollapsible(false);

}

void TabView::update(QWidget *left, QWidget *right)
{

    QWidget* oldRight = splitter->widget(1);
    QWidget* oldLeft  = splitter->widget(0);

    if( oldLeft != NULL )
    {
        oldLeft->hide();
        delete(oldLeft);
    }

    if( oldRight != NULL)
    {
        oldRight->hide();
        delete(oldRight);
    }

    construct(left, right);
}

void TabView::setLeftHeader(QLabel* header)
{
   leftHeader->setText(header->text());
}
