#ifndef TABVIEW_H
#define TABVIEW_H

#include <QWidget>
#include <QSplitter>
#include <QHBoxLayout>
#include <QVBoxLayout>
#include <QLabel>

#include "../NeuralNetwork/NNApprox.h"

struct status
{
    char*  tempLabel;
    char*  hintLabel;
    char*  statusLabel;
    char*  progressLabel;
    double progressBar;
};

class TabView : public QWidget
{
   Q_OBJECT

public:
    TabView();

    virtual status* getStatus() = 0;

signals:
    void networkOpened(NNApprox* nn, QString* filename);
    void networkUpdated(NNApprox* nn);

    void updateNetwork(NNApprox* nn);

    void statusChanged();

protected:
    void construct(QWidget* left, QWidget* right);
    void update(QWidget* left, QWidget* right);
    void setLeftHeader(QLabel* header);

private:
    QSplitter*   splitter;
    QHBoxLayout* layout;

    QVBoxLayout* leftLayout;
    QLabel*      leftHeader;
    QWidget*     leftWidget;

};

#endif // TABVIEW_H
