#ifndef TESTGRAPH_H
#define TESTGRAPH_H

#include "../../../include/qwt_plot.h"
#include "../../../include/qwt_plot_grid.h"
#include "../NeuralNetwork/NNTester.h"
#include "../FileIO/NNData.h"
#include "../../../include/qwt_plot_zoomer.h"

class QwtPlotCurve;

class TestGraph : public QwtPlot
{
    Q_OBJECT

public:
    TestGraph();

public slots:
    void testCycleDone(double percentDone, double error, QString* stats);
    void clearGraph();

    void testStarted(QString* methodName, int numTests, int iter);

    void changeTestMethod(NNTester* tester);

    void testSetLoaded(NNData* testSet);
private:

    QwtPlotCurve *curve;
    QwtPlotZoomer* zoomer;

    double* data;
    double* datax;
    double* totalData;
    int numData;

    double avgerror;
    int index;

    double step;

};

#endif // TESTGRAPH_H
