#ifndef TESTINGVIEWTAB_H
#define TESTINGVIEWTAB_H

#include <Qt3Support>
#include <QIcon>
#include <QMessageBox>
#include <Q3TextEdit>
#include <QGraphicsView>

#include "TabView.h"
#include "TestGraph.h"
#include "../NeuralNetwork/NNTester.h"

class TestingViewTab : public TabView
{
    Q_OBJECT

public slots:
    void testSetLoaded(QString filename);
    void animateLoading(int count);

    void testStarted(QString* methodName, int numTests, int iter);
    void testStopped(QString* stats);

    void changeTestMethod(QString* methodName);
    void testCycleDone(double percentDone, double error, QString* stats);

signals:
    void clearOutput();
    void appendOutput(QString message);

    void doneIteration(double percentDone, double error, QString* stats);
    void startTest(QString* methodName, int numTests, int iter);

    void changeTestMethod(NNTester* tester);
    void testSetLoaded(NNData* testSet);

private:
    QString* currentTestSet;
    int count;
    int testing;

    double progress;
    QString* methodName;
    int numTests;
    int iter;

    int currentIter;

    void error(const char* title, const char* message);

public:
    TestingViewTab();

    virtual status* getStatus();

};

#endif // TESTINGVIEWTAB_H
