#ifndef TRAINGRAPH_H
#define TRAINGRAPH_H

#include "../../../include/qwt_plot.h"
#include "../../../include/qwt_plot_grid.h"
#include "../NeuralNetwork/NNTrainer.h"
#include "../FileIO/NNData.h"
#include "../../../include/qwt_plot_zoomer.h"

class QwtPlotCurve;

class TrainGraph : public QwtPlot
{
    Q_OBJECT

public:
    TrainGraph();

public slots:

    void trainStarted(QString* methodName, int numTrains, int iter, int maxIterations, double gamma, double momentum);
    void constantsChanged(int iter, int maxIterations, double gamma, double momentum);
   

    void clearGraph();


    void changeTrainMethod(NNTrainer* trainer);

    void trainCycleDone(double percentDone, double error, QString* stats);

private:

    QwtPlotCurve *curve;
    QwtPlotZoomer* zoomer;

    double* data;
    double* datax;
    int numData;

    double avgerror;
    int index;

    double step;

};

#endif // TRAINGRAPH_H
