#ifndef TRAININGVIEWTAB_H
#define TRAININGVIEWTAB_H

#include <Qt3Support>
#include <QIcon>
#include <QMessageBox>
#include <Q3TextEdit>
#include <QGraphicsView>

#include "TabView.h"
#include "TrainGraph.h"
#include "../NeuralNetwork/NNTrainer.h"

class TrainingViewTab : public TabView
{
    Q_OBJECT

public slots:
    void trainSetLoaded(QString filename);
    void animateLoading(int count);

    void trainStarted(QString* methodName, int numTrain, int iter, int maxIterations, double gamma, double momentum);
    void trainStopped(QString* stats);

    void changeTrainMethod(QString* methodName);
    void trainCycleDone(double percentDone, double error, QString* stats);

signals:
    void clearOutput();
    void appendOutput(QString message);

     void startTrain(QString* methodName, int numTrains, int iter, int maxIterations, double gamma, double momentum);
     void constantsChanged(int iter, int maxIterations, double gamma, double momentum);

     void changeTrainMethod(NNTrainer* trainer);
     void doneIteration(double percentDone, double error, QString* stats);

private:
    QString* currentTrainSet;
    int count;
    int training;

    double progress;
    QString* methodName;
    int numTrain;
    int iter;
    int maxIterations;
    double gamma;
    double momentum;

    int currentIter;

    void error(const char* title, const char* message);

public:
    TrainingViewTab();

    virtual status* getStatus();

};

#endif // TRAININGVIEWTAB_H
