/**
* Matthew Netsch
* Feb 2010
*
* TTTDeviceSW.h
*
* Implements a Neural Network Device.
* This particular device is a software
* neural network for tic tac toe.
*/

#ifndef TTTDEVICESW_H
#define TTTDEVICESW_H

#include "../../../TAC/NeuralNetwork/NNDevice.h"
#include "../View/TTTDeviceView.h"
#include "../NeuralNetwork/TTTApprox.h"
#include "TTTDeviceSWControls.h"
#include "../GameEngine/TTTEngineThread.h"
#include <QString>
#include <QTextEdit>
#include <QGroupBox>

class TTTDeviceSW : public NNDevice
{
private:
    bool        connected;
    TTTApprox  *myNetwork;

public:
    TTTDeviceSW();
    ~TTTDeviceSW();

    /* Version and Name */
    virtual int getVersion();
    virtual QString* getName();

    /* Weights */
    virtual void load(NNApprox* approx);
    virtual void store(NNApprox* approx);

    /* Connection */
    virtual bool isConnected();
    virtual void testConnection();
    virtual void setConnected(bool connected);

    /* Configure */
    virtual void configure();
    virtual bool isConfigurable();

    virtual void reload();

    /* Evaluate */
    virtual double evaluate(double* inputs, int numInputs);

    virtual void constructViews(NNDevice* device, DeviceView** view, QWidget** controls);

};

#endif // TTTDEVICESW_H
