#include "TTTDeviceSWControls.h"

TTTDeviceSWControls::TTTDeviceSWControls()
{

    layout = new QGridLayout();

    newGameButton = new QPushButton();
    undoMoveButton = new QPushButton();

    XBox         = new QCheckBox("X");
    OBox         = new QCheckBox("O");
    highlightBox = new QCheckBox("Y");

    undoMoveButton->setMaximumSize(QSize(100, 16777215));

    setMaximumHeight(85);
    setMaximumWidth(220);
    setMinimumWidth(220);

    automatePlayerLabel = new QLabel();
    highlightLabel = new QLabel();

    automatePlayerLabel->setText("Automate:");
    highlightLabel->setText("Highlight:");

    newGameButton->setText("New Game");
    undoMoveButton->setText("Undo Move");

    undoMoveButton->setEnabled(false);

    connect(XBox, SIGNAL(stateChanged(int)), this, SIGNAL(XBoxChanged(int)));
    connect(OBox, SIGNAL(stateChanged(int)), this, SIGNAL(OBoxChanged(int)));
    connect(highlightBox, SIGNAL(stateChanged(int)), this, SIGNAL(highlightBoxChanged(int)));
    connect(newGameButton, SIGNAL(clicked()), this, SIGNAL(newGame()));
    connect(undoMoveButton, SIGNAL(clicked()), this, SIGNAL(undoMove()));

    layout->addWidget(automatePlayerLabel, 0, 0, 1, 2, Qt::AlignLeft);
    layout->addWidget(XBox, 0, 2, 1, 1, Qt::AlignRight);
    layout->addWidget(OBox, 0, 3, 1, 1, Qt::AlignRight);
    layout->addWidget(highlightLabel, 1, 0, 1, 2, Qt::AlignLeft);
    layout->addWidget(highlightBox, 1, 3, 1, 1, Qt::AlignRight);
    layout->addWidget(newGameButton, 2, 2, 1, 2, Qt::AlignRight);
    layout->addWidget(undoMoveButton, 2, 0, 1, 2, Qt::AlignLeft);

    setLayout(layout);
}

void TTTDeviceSWControls::canUndo(bool val)
{
    undoMoveButton->setEnabled(val);
}

TTTDeviceSWControls::~TTTDeviceSWControls()
{
    emit stopEngine();
}

void TTTDeviceSWControls::setEngine(TTTEngineThread *engine)
{
    this->engine = engine;

    this->engine->newGame();

    connect(this, SIGNAL(stopEngine()), engine, SLOT(stop()));
}
