#ifndef TTTDEVICESWCONTROLS_H
#define TTTDEVICESWCONTROLS_H

#include <QGridLayout>
#include <QPushButton>
#include <QCheckBox>
#include <QLabel>

#include "../GameEngine/TTTEngineThread.h"

class TTTDeviceSWControls : public QWidget
{
    Q_OBJECT

signals:
    void newGame();
    void undoMove();

    void XBoxChanged ( int state );
    void OBoxChanged ( int state );
    void highlightBoxChanged( int state );

    void stopEngine();

public slots:
    void canUndo(bool val);

public:
    TTTDeviceSWControls();
    ~TTTDeviceSWControls();

    void setEngine(TTTEngineThread* engine);

private:
    QGridLayout* layout;
    QPushButton* newGameButton;
    QPushButton* undoMoveButton;
    QCheckBox*   XBox;
    QCheckBox*   OBox;
    QCheckBox*   highlightBox;
    QLabel*      highlightLabel;
    QLabel*      automatePlayerLabel;

    TTTEngineThread* engine;

};

#endif // TTTDEVICESWCONTROLS_H
