#ifndef __TTTEngine__
#define __TTTEngine__

#include "BoardPosition.h"
#include <cstdio>
#include <cstring>

enum TTTState
{
    DRAW = 0,
    X_WINS = 1,
    O_WINS = 2,
    PLAYING = 3   
};

class TTTEngine
{
      private:
              static const int H = 3;
              static const int W = 3;

              int x1;
              int y1;
              int x2;
              int y2;
              
              BoardPosition* position;
              TTTPiece turn;
              int** moves;
              int numMoves;
              
      public:     
              TTTEngine();
              ~TTTEngine();
              void reset();
              void move(int x, int y);
              void nextTurn();
              void undo();
              void view();
              int getTurn();
              bool canUndo();
              BoardPosition* getPosition();
              int** legalMoves(int* len);
              TTTState pieceToGameState(int piece);
              TTTState getGameState(); 

              int getX1();
              int getY1();
              int getX2();
              int getY2();
              
};

#endif
