#ifndef TTTENGINETHREAD_H
#define TTTENGINETHREAD_H

#include <QThread>
#include <QTimer>

#include "BoardPosition.h"
#include "../../../TAC/NeuralNetwork/NNDevice.h"
#include "TTTEngine.h"

class TTTEngineThread: public QThread

{
Q_OBJECT

public slots:
    void newGame();
    void undoMove();

    void xCheckBox(int state);
    void oCheckBox(int state);

    void clicked(int x, int y);
    void computerClick();

    void stop();

signals:
    void updateBoard(BoardPosition* position, double** weights);
    void showWin(int x1, int y1, int x2, int y2);
    void noWin();

    void gameFinished(int result);
    void canUndo(bool state);

public:
    TTTEngineThread(NNDevice* device);

    virtual void run();

private:
    NNDevice* device;
    TTTEngine* engine;

    bool x, o;

    double** getWeights();
    void update();
    double* position_to_array(BoardPosition* position, int* len);

    QTimer  timer;

    bool running;

};

#endif // TTTENGINETHREAD_H
