#ifndef TTTSERVICELOCATOR_H
#define TTTSERVICELOCATOR_H   


#include "../../TAC/ServiceLocator/ServiceLocator.h"
#include "NeuralNetwork/TTTFactory.h"

class TTTServiceLocator: public ServiceLocator
{

private:
    DeviceProvider* deviceProvider;
    TestProvider*   testProvider;
    TrainerProvider* trainerProvider;

public:
    TTTServiceLocator();

    virtual NNFactory* LocateNNFactory();
    virtual DeviceProvider* LocateDeviceProvider();
    virtual TestProvider*   LocateTestProvider();
    virtual TrainerProvider* LocateTrainerProvider();
    virtual int getVersion();
    virtual char* toString();

    void setDeviceProvider(DeviceProvider* deviceProvider);
    void setTestProvider(TestProvider* testProvider);
    void setTrainerProvider(TrainerProvider* trainerProvider);
};

#endif
