#ifndef TTTDEVICEVIEW_H
#define TTTDEVICEVIEW_H

#include "../../../TAC/View/DeviceView.h"
#include "../GameEngine/BoardPosition.h"

#include <QGraphicsView>
#include <QGraphicsScene>
#include <QGraphicsLineItem>
#include <QMouseEvent>
#include <QResizeEvent>
#include <cstdlib>
#include <cstdio>

class TTTDeviceView : public DeviceView
{
    Q_OBJECT

private:
   /* Widgets */
   QGraphicsScene   *scene;
   QGraphicsItem   **items;

   int  itemCount;

   BoardPosition*  position;

   /* Graph Vars */
   double** weights;
   bool     highlight;
   void     destroyItems();

   bool showRefresh;

   int lastx1, lastx2, lasty1, lasty2;

   QGraphicsItem* winLine;

   bool selfUpdate;

protected:
    void mouseReleaseEvent ( QMouseEvent * event );
    void mouseMoveEvent ( QMouseEvent * event );
    void resizeEvent(QResizeEvent *event);

signals:
    void clicked(int x, int y);

public slots:
    void updateBoard(BoardPosition* position, double** weights);
    void showWin(int x1, int y1, int x2, int y2);
    void noWin();

    void highlightCheck(int status);

public:
    TTTDeviceView();
    virtual void setShowRefresh(bool val);
    

};

#endif // TTTDEVICEVIEW_H
